#include "component_behavior_chase.h"

static void _chase(ComponentBehaviorChase* self, ECS* ecs);

/* DEPENDENCIES: Physics */

static void
_chase(ComponentBehaviorChase* self, ECS* ecs)
{
	ComponentPhysics* physics;
	ComponentPhysics* targetPhysics;
	f32 angle;

	physics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->component.id);
	targetPhysics = ecs_component_get(ecs, ECS_COMPONENT_PHYSICS, self->targetID);

	/* this should not happen. */
	if (!targetPhysics)
		return;

	angle = ATAN
	(
		physics->position[0],
		targetPhysics->position[0],
		physics->position[1],
		targetPhysics->position[1]
	);

	physics->velocity[0] = cos(angle) * self->speed;
	physics->velocity[1] = sin(angle) * self->speed;
}

/* Sets behavior_chase component info. */
void
component_behavior_chase_init(ComponentBehaviorChase* self, f32 speed, u32 targetID)
{
	self->speed = speed;
	self->targetID = targetID;
}

/* Ticks behavior_chase component. */
void
component_behavior_chase_tick(ComponentBehaviorChase* self, ECS* ecs)
{	
	_chase(self, ecs);
}
