#pragma once

#include "../../../GAME_COMMON.h"
#include "../../ecs_entity.h"

#include "component_character.h"
#include "../action/component_action_on_delete_drop_goodies.h"

#define COMPONENT_ENEMY_ALLEGIANCE ALLEGIANCE_ENEMY

typedef struct ComponentEnemy
{
	ECSComponent component;
} ComponentEnemy;

void
component_enemy_init
(
	ComponentEnemy* self,
	ECS* ecs,
	Texture texture,
	ivec2 frameSize,
	ivec2 atlasSize,
	vec2 size,
	vec2 physicsSize,
	vec3 position,
	f32 friction,
	f32 velocityMax,
	u32 healthValue,
	bool isBounce,
	bool isAffectedByGravity,
	bool isSolid,
	u32 goodieCount
);

void component_enemy_add(ComponentEnemy* self, ECS* ecs);
void component_enemy_delete(ComponentEnemy* self, ECS* ecs);

static const ECSComponentInfo COMPONENT_ENEMY_INFO = 
{
	.system = 
	{
		.functions = 
		{ 
			(ECSFunction)component_enemy_add,
			(ECSFunction)component_enemy_delete,
			NULL,
			NULL
		}
	},
	.type = ECS_COMPONENT_ENEMY,
	.size = sizeof(ComponentEnemy)
};


