#include "entity_crumbler.h"

/* Initializes a Crumbler entity. */
void
entity_crumbler_init(ECS* ecs, u32 id, vec3 position, f32 gravity)
{
	ComponentEnemy* enemy;
	ComponentGameObject* gameObject;

	enemy = ecs_component_add(ecs, ECS_COMPONENT_ENEMY, id);
	gameObject = ecs_component_get(ecs, ECS_COMPONENT_GAME_OBJECT, id);

	component_enemy_init
	(
		enemy,
		ecs,
		ecs->game->resources.textures[TEXTURE_CRUMBLER],
		(s32*)CRUMBLER_FRAME_SIZE,
		(s32*)CRUMBLER_ATLAS_SIZE,
		(f32*)CRUMBLER_SIZE,
		(f32*)CRUMBLER_PHYSICS_SIZE,
		position,
		CRUMBLER_FRICTION,
		CRUMBLER_VELOCITY_MAX,
		CRUMBLER_HEALTH_MAX,
		CRUMBLER_IS_BOUNCE,
		CRUMBLER_IS_AFFECTED_BY_GRAVITY,
		CRUMBLER_IS_SOLID,
		CRUMBLER_GOODIE_COUNT
	);

	gameObject->height = CRUMBLER_HEIGHT;
	gameObject->gravity = gravity;
}
