#include "play.h"

static void _play_entity_init(Play* self);

/* Initializes entities for the play state. */
static void
_play_entity_init(Play* self)
{
	self->player = ecs_entity_add(&self->state->game->ecs);
	self->elemental = ecs_entity_add(&self->state->game->ecs);
	
	entity_player_init
	(
		&self->state->game->ecs, 
		self->player, 
		(f32*)PLAY_PLAYER_POSITION
	);

	entity_elemental_init
	(
		&self->state->game->ecs, 
		self->elemental, 
		(f32*)PLAY_ELEMENTAL_POSITION
	);

	for (s32 i = 0; i < 100; i++)
	{
		u32 test;
		vec3 vec;
		vec3 pos = {990.0f, 480.0f, 0.0f};
		f32 height;

		test = ecs_entity_add(&self->state->game->ecs);
		
		vec[0] = RANDOM_F32(-50.0f, 50.0f);
		vec[1] = RANDOM_F32(-50.0f, 50.0f);
		vec[2] = 0.0f;

		height = RANDOM_F32(0.0f, 1000.0f);

		entity_goodie_init
		(
			&self->state->game->ecs,
			test,
			pos,
			vec,
			height
		);
	}

	vec3 testPosition = {1250.0f, 600.0f, 0.0f};
	vec3 testPosition2 = {400.0f, 600.0f, 0.0f};
	vec3 testPosition3 = {800.0f, 800.0f, 0.0f};
	vec3 testPosition4 = {800.0f, 400.0f, 0.0f};
	vec3 testPosition5 = {200.0f, 400.0f, 0.0f};

	entity_cupper_init
	(
		&self->state->game->ecs, 
		ecs_entity_add(&self->state->game->ecs), 
		testPosition,
		self->player
	);

	entity_crumbler_init
	(
		&self->state->game->ecs, 
		ecs_entity_add(&self->state->game->ecs), 
		testPosition2,
		-0.1f
	);

	entity_excorsant_init
	(
		&self->state->game->ecs, 
		ecs_entity_add(&self->state->game->ecs), 
		testPosition3,
		self->player
	);

	entity_custarpedo_init
	(
		&self->state->game->ecs, 
		ecs_entity_add(&self->state->game->ecs), 
		testPosition4,
		self->player
	);

	entity_chipper_init
	(
		&self->state->game->ecs, 
		ecs_entity_add(&self->state->game->ecs), 
		testPosition5,
		self->player
	);
}

/* Initializes play state. */
void
play_init(Play* self, State* state)
{
	memset(self, '\0', sizeof(Play));

	self->state = state;
	
	_play_entity_init(self);
}
