#pragma once

#include "../STATE_COMMON.h"

#include "../../ecs/ecs.h"

#include "../../ecs/entity/play/entity_player.h"
#include "../../ecs/entity/play/entity_goodie.h"
#include "../../ecs/entity/play/entity_elemental.h"
#include "../../ecs/entity/play/entity_cupper.h"
#include "../../ecs/entity/play/entity_crumbler.h"
#include "../../ecs/entity/play/entity_excorsant.h"
#include "../../ecs/entity/play/entity_custarpedo.h"
#include "../../ecs/entity/play/entity_chipper.h"

static const vec3 PLAY_PLAYER_POSITION = {990.0f, 800.0f, 0.0f};
static const vec3 PLAY_ELEMENTAL_POSITION = {990.0f, 500.0f, 0.0f};

#define PLAY_SHADER_COUNT 2
static const ShaderType PLAY_SHADERS[PLAY_SHADER_COUNT] =
{
	SHADER_TEXTURE_QUAD,
	SHADER_COLOR_QUAD
};

#define PLAY_TEXTURE_COUNT 17
static const TextureType PLAY_TEXTURES[PLAY_TEXTURE_COUNT] =
{
	TEXTURE_SHADOW,
	TEXTURE_PLAYER,
	TEXTURE_ELEMENTAL,
	TEXTURE_CUPPER,
	TEXTURE_CHIPPER,
	TEXTURE_CRUMBLER,
	TEXTURE_CUSTARPEDO,
	TEXTURE_EXCORSANT,
	TEXTURE_ROCK_CANDY_MICHEAL,
	TEXTURE_NEAPOLITOTEM,
	TEXTURE_EZ_ACHE,
	TEXTURE_CREPER,
	TEXTURE_GUM_MK_II,
	TEXTURE_SNAKE,
	TEXTURE_CHIP,
	TEXTURE_GUMBALL,
	TEXTURE_GOODIES
};

void play_init(Play* play, State* state);
